#ifdef __BIDE__
// Definitions for Borland IDE + debugger
#define _NO_VCL
#include "condefs.h"
#define WinMain WinMain
	//USERC("name_of_res_file.rc");
USELIB("..\..\lib\zlib.lib");
USELIB("..\..\lib\odbc32.lib");
USELIB("..\..\lib\regex.lib");
USELIB("..\..\lib\tiff.lib");
USELIB("..\..\lib\winpng.lib");
USELIB("..\..\lib\wx32ds.lib");
USELIB("..\..\lib\jpeg.lib");
USEUNIT("ptopengui_ui.cpp");
USEUNIT("ptopengui_parser.cpp");
//---------------------------------------------------------------------------
#endif

# ifdef __GNUG__
  #pragma implementation "ptopengui.h"
#endif

#include "wx/wxprec.h"
#include <wx/image.h>
#include <wx/statline.h>
#include <wx/spinbutt.h>
#include <wx/spinctrl.h>
#include <wx/splitter.h>
#include <wx/listctrl.h>
#include <wx/treectrl.h>
#include <wx/notebook.h>
#include <wx/grid.h>
//#include "wx/file.h"
//#include "wx/log.h"

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#include "ptopengui.h"

#if defined(__WXGTK__) || defined(__WXMOTIF__)
  #include "ptopengui.xpm"
#endif

BEGIN_EVENT_TABLE(MainFrame,wxFrame)
  EVT_MENU(ID_TEST, MainFrame::OnTest)
  EVT_MENU(ID_OPEN, MainFrame::OnOpen)
  EVT_MENU(ID_SAVE, MainFrame::OnSave)
  EVT_MENU(ID_EDIT, MainFrame::OnEdit)
  EVT_BUTTON(ID_EDIT, MainFrame::OnEdit)
  EVT_MENU(ID_QUIT, MainFrame::OnQuit)
  EVT_CLOSE(MainFrame::OnCloseWindow)
  EVT_MENU(ID_ABOUT, MainFrame::OnAbout)
END_EVENT_TABLE()

MainFrame::MainFrame( wxWindow *parent, wxWindowID id, const wxString &title,
   const wxPoint &position, const wxSize& size, long style, wxLocale& l )
   : wxFrame( parent, id, title, position, size, style),
     m_locale(l)
{
  CreateMainMenuBar();

  // the notebook
  main_panel = (wxPanel*) NULL;
  main_panel = new wxPanel(this, -1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL|wxCLIP_CHILDREN);
  DialogFunc( main_panel, TRUE , TRUE );

#if wxUSE_STATUSBAR
  CreateStatusBar(2);
  SetStatusText( _("PTOpenGui is ready") );
#endif

  SetIcon(wxICON(ptopengui));
}

void MainFrame::CreateMainMenuBar()
{
#ifdef __WXMAC__
  wxApp::s_macAboutMenuItemId = ID_ABOUT;
#endif

  wxMenu *file_menu = new wxMenu;
  file_menu->Append( ID_ABOUT, _("New"), _("New project") );
  file_menu->Append( ID_OPEN, _("&Open project\tCtrl-o"), wxT("") );
  file_menu->Append( ID_SAVE, _("&Save project\tCtrl-s"), wxT("") );
  file_menu->Append( ID_TEST, _("Save project As"), wxT("") );
  file_menu->Append( ID_TEST, _("Close project"), wxT("") );
  file_menu->Append( ID_TEST, _("Preferences"), wxT("") );
  file_menu->AppendSeparator();
  file_menu->Append( ID_QUIT, _("E&xit\tCtrl-q"), _("Quit PTOpenGui") );

  wxMenu *edit_menu = new wxMenu;
  edit_menu->Append( ID_EDIT, _("Project in text format\tF2"), _("Set parameters. view datas") );
  edit_menu->Append( ID_ABOUT, _("Fine tune control point"), _("Experimental function") );
  edit_menu->Append( ID_ABOUT, _("Add control point"), _("Same function as add button") );
  edit_menu->Append( ID_ABOUT, _("Update control point"), _("Same function as update button") );

  wxMenu *view_menu = new wxMenu;
  view_menu->Append( ID_ABOUT, _("&Control point table\tF3"), _("Shows all controlpoint distances") );
  view_menu->Append( ID_ABOUT, _("&Optimized control points"), _("Last optimization result") );
  view_menu->Append( ID_ABOUT, _("&Last preview stitch"), wxT("") );

  wxMenu *opts_menu = new wxMenu;
  opts_menu->Append( ID_ABOUT, _("&Hide statusbar"), _("Toggle statusbar visibility"), TRUE );
  opts_menu->Append( ID_ABOUT, _("&Auto optimization\tF4"), _("Toggle optimization status"), TRUE );
  opts_menu->Append( ID_ABOUT, _("&Other\tF8"), _("General settings") );

  wxMenu *exec_menu = new wxMenu;
  exec_menu->Append( ID_ABOUT, _("&Optimization\tCtrl-r"), _("Optimize with current parameters") );
  exec_menu->Append( ID_ABOUT, _("&Accept previous optimization result\tCtrl-Alt-a"), _("Last result was OK?") );
  exec_menu->Append( ID_ABOUT, _("&Preview\tCtrl-p"), wxT("") );

  wxMenu *help_menu = new wxMenu;
  help_menu->Append( ID_ABOUT, _("About") );

  wxMenuBar *menu_bar = new wxMenuBar();
  menu_bar->Append( file_menu, _("&File") );
  menu_bar->Append( edit_menu, _("&Edit") );
  menu_bar->Append( view_menu, _("&View") );
  menu_bar->Append( opts_menu, _("&Options") );
  menu_bar->Append( exec_menu, _("&Execute") );
  menu_bar->Append( help_menu, _("&Help") );

#ifndef __WIN95__
  // commented in Win95 by JuHe as assert says that this cannot be checked
  menu_bar->Check(ID_ABOUT, TRUE);
#endif

  SetMenuBar( menu_bar );
}

void MainFrame::OnOpen( wxCommandEvent &event )
{
  wxString str;
  wxFileDialog *dlg = new wxFileDialog(this,_("Open project file"), "", "",
	"Project files (*.pto)|*.pto|All files (*.*)|*.*", wxOPEN, wxDefaultPosition);
  if (dlg->ShowModal() == wxID_OK) {
	str = dlg->GetFilename();
	SetStatusText( _("Open project: ")+str);
  } else {
	// do not close old project
  }
  dlg->Destroy();
  if (str == wxT("")) {
	// nothing to open
	SetStatusText( _("Open project: cancel"));
	return;
  }
  // parse project
  //OpenProject(str);
  // store current project name as last opened project
#if 0
	// code from: TFormMain::Open1Click(TObject *Sender)
	AnsiString str;
	if (Sender != 0) {
		//CloseProjectClick(0);
		TRegistry &regKey = *new TRegistry();
		regKey.OpenKey(
			"Software\\JuHe\\PTOpenGui", true);
		try {
			OpenDialogProject->InitialDir = regKey.ReadString("LastProjDir");
			OpenDialogProject->FileName = regKey.ReadString("LastProjFile");
			OpenDialogProject->FilterIndex = regKey.ReadInteger("FilterProjIndex");
		} catch (ERegistryException &e) {}
		delete &regKey;
		if (!OpenDialogProject->Execute()) {
			return;
		}
	} else {
		str = ExtractFilePath(OpenDialogProject->FileName);
		if (str.Length() > 0) {
			//OpenDialogProject->InitialDir = str;
			// change current working directory on specified _drive_
			// currently needed only in debug and when parameter is non zero
			chdir(str.c_str());
		}
	}
	CloseProjectClick(0);
	{
		OpenProject(OpenDialogProject->FileName);
		TRegistry &regKey = *new TRegistry();
		regKey.OpenKey(
			"Software\\JuHe\\PTOpenGui", true);
		str = ExtractFilePath(OpenDialogProject->FileName);
		regKey.WriteString("LastProjDir", str);
		str = ExtractFileName(OpenDialogProject->FileName);
		regKey.WriteString("LastProjFile", str);
		regKey.WriteInteger
			("FilterProjIndex", OpenDialogProject->FilterIndex);
		delete &regKey;
		TabbedNotebook1Change(0,TabbedNotebook1->PageIndex,allowChange);
		MemoProjectEnter(0);
		Fainf.fov_not_yet_set = false;	// no automatical update
	}
#endif
}

void MainFrame::OnSave( wxCommandEvent &event )
{
}

void MainFrame::OnEdit( wxCommandEvent &event )
{
  wxDialog edit_dialog( this, -1, _("PTOpenGui - Text mode"), wxDefaultPosition );
  edit_dialog.SetSizeHints( 600, 800, 700, 800);
  ProjectEditFunc( &edit_dialog, TRUE );
  edit_dialog.CentreOnParent();
  edit_dialog.ShowModal();
#if 0
	bool allowChange = true;
	FormParser->PrintScript(PRINT_PROJECT,&Fainf);
	FormParser->ShowModal();
	ButtonUpdateProjectMemoClick(0);
	MemoStitchScript->Clear();
	// opadate page 0: TabbedNotebook1Change(0,TabbedNotebook1->PageIndex,allowChange);
#endif
}

void MainFrame::OnTest( wxCommandEvent &event )
{
  wxDialog dialog( this, -1, _("PTOpenGui"), wxDefaultPosition );
  DialogFunc( &dialog, TRUE );
  dialog.CentreOnParent();
  dialog.ShowModal();
}

void MainFrame::OnQuit( wxCommandEvent &event )
{
  Close( TRUE );
}

void MainFrame::OnCloseWindow( wxCloseEvent &event )
{
  Destroy();
}

void MainFrame::OnAbout( wxCommandEvent &event )
{
  wxMessageDialog dialog( this, _("PTOpenGui\nVersion:           0.8pre_wx\nCompile date:   2003/04/11\n\nCopyright 2003 Juha Helminen  2003\nunder the GPL\n\nURL: http://www.nic.fi/~juhe/ptbcgui/"),
	_("About PTOpenGui"), wxOK|wxICON_INFORMATION );
  dialog.ShowModal();
  dialog.Show(TRUE);
}


IMPLEMENT_APP(PTOpenGui)

PTOpenGui::PTOpenGui()
{
}

bool PTOpenGui::OnInit()
{
  m_locale.Init(wxLANGUAGE_DEFAULT);
  m_locale.AddCatalog(wxT("ptopengui"));      // 2) our private one
/*#ifdef __LINUX__
    {
    wxLogNull noLog;
    m_locale.AddCatalog(_T("fileutils"));  // 3) and another just for testing
    }
#endif*/

  MainFrame *frame = new MainFrame( NULL, -1, _("PTOpenGui"), wxPoint(20,20), wxSize(830,690) , wxMAXIMIZE_BOX , m_locale );

  frame->Show( TRUE );

  return TRUE;
}

int PTOpenGui::OnExit()
{
  return 0;
}


wxSizer *DialogFunc( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

    wxNotebook *item2 = new wxNotebook( parent, ID_NOTEBOOK, wxDefaultPosition, wxDefaultSize, 0 );
    wxNotebookSizer *item1 = new wxNotebookSizer( item2 );

    wxPanel *item3 = new wxPanel( item2, -1 );
    Page1Func( item3, FALSE );
    item2->AddPage( item3, _("Files") );

    wxPanel *item4 = new wxPanel( item2, -1 );
    Page2Func( item4, FALSE );
    item2->AddPage( item4, _("Lens settings") );

    wxPanel *item5 = new wxPanel( item2, -1 );
    Page3Func( item5, FALSE );
    item2->AddPage( item5, _("Panorama settings") );

    wxPanel *item6 = new wxPanel( item2, -1 );
    Page4Func( item6, FALSE );
    item2->AddPage( item6, _("Image settings") );

    wxPanel *item7 = new wxPanel( item2, -1 );
    Page5Func( item7, FALSE );
    item2->AddPage( item7, _("Control points") );

    wxPanel *item14 = new wxPanel( item2, -1 );
    Page6Func( item14, FALSE );
    item2->AddPage( item14, _("Optimize") );

    wxPanel *item15 = new wxPanel( item2, -1 );
    Page7Func( item15, FALSE );
    item2->AddPage( item15, _("Preview") );

    wxPanel *item16 = new wxPanel( item2, -1 );
    Page8Func( item16, FALSE );
    item2->AddPage( item16, _("Stitch") );

    item0->Add( item1, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxStaticLine *item10 = new wxStaticLine( parent, ID_LINE, wxDefaultPosition, wxSize(20,-1), wxLI_HORIZONTAL );
    item0->Add( item10, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxBoxSizer *item11 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item12 = new wxButton( parent, wxID_OK, _("OK"), wxDefaultPosition, wxDefaultSize, 0 );
    item12->SetDefault();
    item11->Add( item12, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item13 = new wxButton( parent, wxID_CANCEL, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    item11->Add( item13, 0, wxALIGN_CENTRE|wxALL, 5 );

    item0->Add( item11, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxBOTTOM, 0 );

    if (set_sizer)
    {
        parent->SetAutoLayout( TRUE );
        parent->SetSizer( item0 );
        if (call_fit)
        {
            item0->Fit( parent );
            item0->SetSizeHints( parent );
        }
    }
    
    return item0;
}

wxSizer *Page1Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
  wxBoxSizer *item0 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item1 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item2 = new wxStaticText( parent, ID_TEXT, _("Image files"), wxDefaultPosition, wxDefaultSize, 0 );
  item1->Add( item2, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxListCtrl *filelist = new wxListCtrl( parent, ID_LISTCTRL, wxDefaultPosition, wxSize(160,120), wxLC_REPORT|wxSUNKEN_BORDER );
  filelist->SetToolTip( _("image in project") );
  item1->Add( filelist, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );
  filelist->InsertColumn( 0, _("#"), wxLIST_FORMAT_LEFT, 25 );
  filelist->InsertColumn( 1, _("Filename"), wxLIST_FORMAT_LEFT, 270 );
  filelist->InsertColumn( 2, _("width"), wxLIST_FORMAT_LEFT, 60 );
  filelist->InsertColumn( 3, _("height"), wxLIST_FORMAT_LEFT, 60 );
  filelist->InsertColumn( 4, _("rotate"), wxLIST_FORMAT_LEFT, 60 );
  // Here comes an sample entry 
  wxString buf;
  int filenumber;
  filenumber=0;
  buf.Printf( _("%d"), filenumber);
  filelist->InsertItem(0, buf, 0);
  buf.Printf( _("--------"));
  filelist->SetItem(0, 1, buf);
  buf.Printf( _("%d"), filenumber);
  filelist->SetItem(0, 2, buf);
  filelist->SetItem(0, 3, buf);
  filelist->SetItem(0, 4, buf);

  wxBoxSizer *item4 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item5 = new wxStaticText( parent, ID_TEXT, _("Project file"), wxDefaultPosition, wxDefaultSize, 0 );
  item4->Add( item5, 0, wxALIGN_CENTRE|wxALL, 5 );

  item4->Add( 120, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item6 = new wxButton( parent, ID_EDIT, _("Edit project"), wxDefaultPosition, wxDefaultSize, 0 );
  item6->SetToolTip( _("Show project in project parser") );
  item4->Add( item6, 0, wxALIGN_CENTRE|wxALL, 5 );

  item1->Add( item4, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxTextCtrl *item7 = new wxTextCtrl( parent, ID_TEXTCTRL, _("#- scanResolution 2900.00000"), wxDefaultPosition, wxSize(480,262), wxTE_MULTILINE|wxVSCROLL|wxHSCROLL );
  item7->SetToolTip( _("Project description") );
  item1->Add( item7, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item0->Add( item1, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxBoxSizer *item8 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item9 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticBox *item11 = new wxStaticBox( parent, -1, _("File operations") );
  wxStaticBoxSizer *item10 = new wxStaticBoxSizer( item11, wxVERTICAL );

  wxButton *item12 = new wxButton( parent, ID_BUTTON, _("Add"), wxDefaultPosition, wxDefaultSize, 0 );
  item12->SetToolTip( _("Add new image to project") );
  item10->Add( item12, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item13 = new wxButton( parent, ID_BUTTON, _("Remove"), wxDefaultPosition, wxDefaultSize, 0 );
  item13->SetToolTip( _("Remove image from project") );
  item10->Add( item13, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item14 = new wxButton( parent, ID_BUTTON, _("Up"), wxDefaultPosition, wxDefaultSize, 0 );
  item14->SetToolTip( _("Move image up in list") );
  item10->Add( item14, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item15 = new wxButton( parent, ID_BUTTON, _("Down"), wxDefaultPosition, wxDefaultSize, 0 );
  item15->SetToolTip( _("Move image down in list") );
  item10->Add( item15, 0, wxALIGN_CENTRE|wxALL, 5 );

  item9->Add( item10, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxStaticBox *item17 = new wxStaticBox( parent, -1, _("Export project") );
  wxStaticBoxSizer *item16 = new wxStaticBoxSizer( item17, wxVERTICAL );

  wxStaticText *item18 = new wxStaticText( parent, ID_TEXT, _("Scale factor:"), wxDefaultPosition, wxDefaultSize, 0 );
  item16->Add( item18, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item19 = new wxTextCtrl( parent, ID_TEXTCTRL, _("1"), wxDefaultPosition, wxSize(80,-1), 0 );
  item19->SetToolTip( _("image scale ratio") );
  item16->Add( item19, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxCheckBox *item20 = new wxCheckBox( parent, ID_CHECKBOX, _("Integer value"), wxDefaultPosition, wxDefaultSize, 0 );
  item20->SetToolTip( _("Round control point numbers to whole numbers") );
  item16->Add( item20, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item21 = new wxButton( parent, ID_BUTTON, _("Export"), wxDefaultPosition, wxDefaultSize, 0 );
  item21->SetToolTip( _("Experimential function...") );
  item16->Add( item21, 0, wxALIGN_CENTRE|wxALL, 5 );

  item9->Add( item16, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item8->Add( item9, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticBox *item23 = new wxStaticBox( parent, -1, _("Preview (source image)") );
  wxStaticBoxSizer *item22 = new wxStaticBoxSizer( item23, wxVERTICAL );

  wxPanel *item24 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(256,256), 0 );
  item22->Add( item24, 0, wxALIGN_CENTRE|wxALL, 5 );

  item8->Add( item22, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 10 );

  item0->Add( item8, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  if (set_sizer)
  {
    parent->SetAutoLayout( TRUE );
    parent->SetSizer( item0 );
    if (call_fit)
    {
      item0->Fit( parent );
      item0->SetSizeHints( parent );
    }
  }

  return item0;
}

wxSizer *Page2Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
  wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item1 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item2 = new wxStaticText( parent, ID_TEXT, _("Lens type:"), wxDefaultPosition, wxDefaultSize, 0 );
  item2->SetToolTip( _("Lens type") );
  item1->Add( item2, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxString strs3[] = 
  {
    _("Normal (rectlinear)"), 
    _("Panoramic"), 
    _("Circular"), 
    _("Full frame"), 
    _("Equirectangular")
  };
  wxComboBox *item3 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(150,-1), 5, strs3, wxCB_DROPDOWN );
  item1->Add( item3, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item4 = new wxStaticText( parent, ID_TEXT, _("All images/names"), wxDefaultPosition, wxDefaultSize, 0 );
  item1->Add( item4, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxString strs5[] = 
  {
    _("All")
  };
  wxComboBox *item5 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(100,-1), 1, strs5, wxCB_DROPDOWN|wxCB_SORT );
  item5->SetToolTip( _("All or one image") );
  item1->Add( item5, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxCheckBox *item6 = new wxCheckBox( parent, ID_CHECKBOX, _("Change single image only"), wxDefaultPosition, wxDefaultSize, 0 );
  item6->SetToolTip( _("Do not change values for all images at the one time") );
  item1->Add( item6, 0, wxALIGN_CENTRE|wxALL, 5 );

  item0->Add( item1, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item7 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticBox *item9 = new wxStaticBox( parent, -1, _("Horizontal Field of View") );
  wxStaticBoxSizer *item8 = new wxStaticBoxSizer( item9, wxVERTICAL );

  wxRadioButton *item10 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Degrees"), wxDefaultPosition, wxDefaultSize, 0 );
  item10->SetToolTip( _("Set lens type calculation method") );
  item8->Add( item10, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxRadioButton *item11 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Lens in mm for 35mm film"), wxDefaultPosition, wxDefaultSize, 0 );
  item11->SetToolTip( _("Set lens type calculation method") );
  item8->Add( item11, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxRadioButton *item12 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Scanned film"), wxDefaultPosition, wxDefaultSize, 0 );
  item12->SetToolTip( _("Set lenstype calculation method") );
  item8->Add( item12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item7->Add( item8, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxStaticBox *item14 = new wxStaticBox( parent, -1, _("Degrees") );
  wxStaticBoxSizer *item13 = new wxStaticBoxSizer( item14, wxHORIZONTAL );

  wxBoxSizer *item15 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item16 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item17 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item18 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item19 = new wxStaticText( parent, ID_TEXT, _("Degrees (v):"), wxDefaultPosition, wxDefaultSize, 0 );
  item18->Add( item19, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item20 = new wxTextCtrl( parent, ID_TEXTCTRL, _("54"), wxDefaultPosition, wxSize(80,-1), 0 );
  item20->SetToolTip( _("Calculated field of view") );
  item18->Add( item20, 0, wxALIGN_CENTRE|wxALL, 5 );

  item17->Add( item18, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item21 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item22 = new wxStaticText( parent, ID_TEXT, _("Focal lenght:"), wxDefaultPosition, wxDefaultSize, 0 );
  item21->Add( item22, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item23 = new wxTextCtrl( parent, ID_TEXTCTRL, _("35"), wxDefaultPosition, wxSize(80,-1), 0 );
  item23->SetToolTip( _("Actual focal length if ppi setting is used ") );
  item21->Add( item23, 0, wxALIGN_CENTRE|wxALL, 5 );

  item17->Add( item21, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item24 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item25 = new wxStaticText( parent, ID_TEXT, _("image ppi:"), wxDefaultPosition, wxDefaultSize, 0 );
  item24->Add( item25, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item26 = new wxTextCtrl( parent, ID_TEXTCTRL, _("2900"), wxDefaultPosition, wxSize(80,-1), 0 );
  item26->SetToolTip( _("Set image resolution (film ppi or CCD cell ppi)") );
  item24->Add( item26, 0, wxALIGN_CENTRE|wxALL, 5 );

  item17->Add( item24, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item16->Add( item17, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 0 );

  wxBoxSizer *item27 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item28 = new wxStaticText( parent, ID_TEXT, _("(horizontal field of view)"), wxDefaultPosition, wxDefaultSize, 0 );
  item27->Add( item28, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item29 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item30 = new wxStaticText( parent, ID_TEXT, _("Orientation"), wxDefaultPosition, wxDefaultSize, 0 );
  item30->Enable( FALSE );
  item29->Add( item30, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxString strs31[] = 
  {
    _("ComboItem")
  };
  wxComboBox *item31 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(100,-1), 1, strs31, wxCB_DROPDOWN );
  item31->Enable( FALSE );
  item29->Add( item31, 0, wxALIGN_CENTRE|wxALL, 5 );

  item27->Add( item29, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item32 = new wxStaticText( parent, ID_TEXT, _("Set for digi images also if they are cropped"), wxDefaultPosition, wxDefaultSize, 0 );
  item27->Add( item32, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item16->Add( item27, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item15->Add( item16, 0, wxALIGN_CENTRE|wxALL, 0 );

  wxStaticText *item33 = new wxStaticText( parent, ID_TEXT, _("Degrees are calculated according to crop focal length"), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item33, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item13->Add( item15, 0, wxALIGN_CENTRE|wxALL, 5 );

  item7->Add( item13, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item0->Add( item7, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item34 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticBox *item36 = new wxStaticBox( parent, -1, _("Lens correction parameters") );
  wxStaticBoxSizer *item35 = new wxStaticBoxSizer( item36, wxVERTICAL );

  wxBoxSizer *item37 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item38 = new wxStaticText( parent, ID_TEXT, _("             a:"), wxDefaultPosition, wxDefaultSize, 0 );
  item37->Add( item38, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item39 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(80,-1), 0 );
  item39->SetToolTip( _("a - distortion value") );
  item37->Add( item39, 0, wxALIGN_CENTRE|wxALL, 0 );

  item37->Add( 20, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

  item35->Add( item37, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item40 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item41 = new wxStaticText( parent, ID_TEXT, _("b:"), wxDefaultPosition, wxDefaultSize, 0 );
  item40->Add( item41, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item42 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(80,-1), 0 );
  item42->SetToolTip( _("Barrel or pincusion distortion") );
  item40->Add( item42, 0, wxALIGN_CENTRE|wxALL, 0 );

  item40->Add( 20, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

  item35->Add( item40, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item43 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item44 = new wxStaticText( parent, ID_TEXT, _("c:"), wxDefaultPosition, wxDefaultSize, 0 );
  item43->Add( item44, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item45 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(80,-1), 0 );
  item45->SetToolTip( _("c - distortion value") );
  item43->Add( item45, 0, wxALIGN_CENTRE|wxALL, 0 );

  item43->Add( 20, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

  item35->Add( item43, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item34->Add( item35, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxStaticBox *item47 = new wxStaticBox( parent, -1, _("Image shift") );
  wxStaticBoxSizer *item46 = new wxStaticBoxSizer( item47, wxVERTICAL );

  wxBoxSizer *item48 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item49 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item50 = new wxStaticText( parent, ID_TEXT, _("Shift:"), wxDefaultPosition, wxDefaultSize, 0 );
  item49->Add( item50, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item51 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item52 = new wxStaticText( parent, ID_TEXT, _("horizontal (d): "), wxDefaultPosition, wxDefaultSize, 0 );
  item51->Add( item52, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item53 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item51->Add( item53, 0, wxALIGN_CENTRE|wxALL, 0 );

  item49->Add( item51, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item54 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item55 = new wxStaticText( parent, ID_TEXT, _("vertical (e): "), wxDefaultPosition, wxDefaultSize, 0 );
  item54->Add( item55, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item56 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item54->Add( item56, 0, wxALIGN_CENTRE|wxALL, 0 );

  item49->Add( item54, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxStaticText *item57 = new wxStaticText( parent, ID_TEXT, _("Shear:"), wxDefaultPosition, wxDefaultSize, 0 );
  item49->Add( item57, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item58 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item59 = new wxStaticText( parent, ID_TEXT, _("horizontal (g): "), wxDefaultPosition, wxDefaultSize, 0 );
  item58->Add( item59, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item60 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item58->Add( item60, 0, wxALIGN_CENTRE|wxALL, 0 );

  item49->Add( item58, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item61 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item62 = new wxStaticText( parent, ID_TEXT, _("vertical (f): "), wxDefaultPosition, wxDefaultSize, 0 );
  item61->Add( item62, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item63 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item61->Add( item63, 0, wxALIGN_CENTRE|wxALL, 0 );

  item49->Add( item61, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item48->Add( item49, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticLine *item64 = new wxStaticLine( parent, ID_LINE, wxDefaultPosition, wxSize(20,20), wxLI_VERTICAL );
  item48->Add( item64, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxBoxSizer *item65 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item66 = new wxStaticText( parent, ID_TEXT, _("Set rest in text file ..."), wxDefaultPosition, wxDefaultSize, 0 );
  item65->Add( item66, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item67 = new wxButton( parent, ID_BUTTON, _("Edit text"), wxDefaultPosition, wxDefaultSize, 0 );
  item65->Add( item67, 0, wxALIGN_CENTRE|wxALL, 5 );

  item48->Add( item65, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item46->Add( item48, 0, wxALIGN_CENTRE|wxALL, 5 );

  item34->Add( item46, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item0->Add( item34, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  if (set_sizer)
  {
    parent->SetAutoLayout( TRUE );
    parent->SetSizer( item0 );
    if (call_fit)
    {
      item0->Fit( parent );
      item0->SetSizeHints( parent );
    }
  }
    
  return item0;
}

wxSizer *Page3Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
  wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item1 = new wxStaticText( parent, ID_TEXT, _("Settings for final panorama"), wxDefaultPosition, wxDefaultSize, 0 );
  item0->Add( item1, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxBoxSizer *item2 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item3 = new wxBoxSizer( wxVERTICAL );

  wxStaticBox *item5 = new wxStaticBox( parent, -1, _("View type") );
  wxStaticBoxSizer *item4 = new wxStaticBoxSizer( item5, wxVERTICAL );

  wxStaticText *item6 = new wxStaticText( parent, ID_TEXT, _("Panorama type (f)"), wxDefaultPosition, wxDefaultSize, 0 );
  item4->Add( item6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxString strs7[] = 
  {
    _("Rectlinear"), 
    _("Cylindrical"), 
     _("Equirectangular")
  };
  wxComboBox *item7 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(120,20), 3, strs7, wxCB_DROPDOWN );
  item7->SetToolTip( _("Panorama projection") );
  item4->Add( item7, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item4->Add( 20, 10, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item8 = new wxStaticText( parent, ID_TEXT, _("Field of view (v)"), wxDefaultPosition, wxDefaultSize, 0 );
  item4->Add( item8, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  wxBoxSizer *item9 = new wxBoxSizer( wxHORIZONTAL );

  wxTextCtrl *item10 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item10->SetToolTip( _("Field of view in stitched panorama") );
  item9->Add( item10, 0, wxALIGN_CENTRE|wxALL, 0 );

  wxButton *item11 = new wxButton( parent, ID_BUTTON, _("Get max"), wxDefaultPosition, wxDefaultSize, 0 );
  item9->Add( item11, 0, wxALIGN_CENTRE|wxALL, 5 );

  item4->Add( item9, 0, wxALIGN_CENTRE|wxALL, 0 );

  item3->Add( item4, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticBox *item13 = new wxStaticBox( parent, -1, _("Stitching parameters") );
  wxStaticBoxSizer *item12 = new wxStaticBoxSizer( item13, wxVERTICAL );

  wxStaticText *item14 = new wxStaticText( parent, ID_TEXT, _("Feather (u): "), wxDefaultPosition, wxDefaultSize, 0 );
  item12->Add( item14, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item15 = new wxTextCtrl( parent, ID_TEXTCTRL, _("10"), wxDefaultPosition, wxSize(80,-1), 0 );
  item15->SetToolTip( _("Feather of images for stitching") );
  item12->Add( item15, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item16 = new wxStaticText( parent, ID_TEXT, _("Gamma (g): "), wxDefaultPosition, wxDefaultSize, 0 );
  item12->Add( item16, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item17 = new wxTextCtrl( parent, ID_TEXTCTRL, _("1"), wxDefaultPosition, wxSize(80,-1), 0 );
  item17->SetToolTip( _("Gamma correction (works best for 16bit images)") );
  item12->Add( item17, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item18 = new wxStaticText( parent, ID_TEXT, _("Interpolator (i): "), wxDefaultPosition, wxDefaultSize, 0 );
  item12->Add( item18, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxString strs19[] = 
  {
    _("Nearest neighbour"), 
    _("Bilinear"), 
    _("Poly3 (Bicubic)"), 
    _("Spline 16"), 
    _("Spline 32"), 
    _("Spline 64"), 
    _("Sinc 256"), 
    _("Sinc 1024")
  };
  wxComboBox *item19 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(140,-1), 8, strs19, wxCB_DROPDOWN );
  item19->SetToolTip( _("Method for resize/interpolate") );
  item12->Add( item19, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item3->Add( item12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item2->Add( item3, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxBoxSizer *item20 = new wxBoxSizer( wxVERTICAL );

  wxStaticBox *item22 = new wxStaticBox( parent, -1, _("Output file") );
  wxStaticBoxSizer *item21 = new wxStaticBoxSizer( item22, wxHORIZONTAL );

  wxBoxSizer *item23 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item24 = new wxStaticText( parent, ID_TEXT, _("Width"), wxDefaultPosition, wxDefaultSize, 0 );
  item23->Add( item24, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item25 = new wxTextCtrl( parent, ID_TEXTCTRL, _("2000"), wxDefaultPosition, wxSize(80,-1), 0 );
  item25->SetToolTip( _("Width of panorama") );
  item23->Add( item25, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item26 = new wxStaticText( parent, ID_TEXT, _("Height"), wxDefaultPosition, wxDefaultSize, 0 );
  item23->Add( item26, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item27 = new wxTextCtrl( parent, ID_TEXTCTRL, _("1000"), wxDefaultPosition, wxSize(80,-1), 0 );
  item27->SetToolTip( _("Height of panorama") );
  item23->Add( item27, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item21->Add( item23, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  wxBoxSizer *item28 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item29 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item30 = new wxStaticText( parent, ID_TEXT, _("Output file type"), wxDefaultPosition, wxDefaultSize, 0 );
  item29->Add( item30, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxString strs31[] = 
  {
    _("JPEG (*.jpg)"), 
    _("PNG (*.png)"), 
    _("TIFF (*.tif)"), 
    _("TIFF_mask (*.tif)"), 
    _("TIFF_nomask (*.tif)"), 
    _("PICT Bitmap (*.bmp)"), 
    _("PSD Photoshop (*.psd)"), 
    _("PSD_mask"), 
    _("PSD_nomask"), 
    _("PAN"), 
    _("IVR"), 
    _("IVR_java"), 
    _("VRML"), 
    _("QTVR")
  };
  wxComboBox *item31 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(160,-1), 14, strs31, wxCB_DROPDOWN );
  item31->SetToolTip( _("Image file type") );
  item29->Add( item31, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item32 = new wxStaticText( parent, ID_TEXT, _("Jpeg quality: (used in preview)"), wxDefaultPosition, wxDefaultSize, 0 );
  item29->Add( item32, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxBoxSizer *item33 = new wxBoxSizer( wxHORIZONTAL );

  wxTextCtrl *item34 = new wxTextCtrl( parent, ID_TEXTCTRL, _("90"), wxDefaultPosition, wxSize(80,-1), 0 );
  item34->SetToolTip( _("Quality value, 100% best, 0% least space") );
  item33->Add( item34, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxCheckBox *item35 = new wxCheckBox( parent, ID_CHECKBOX, _("Progressive jpeg"), wxDefaultPosition, wxDefaultSize, 0 );
  item35->SetToolTip( _("Jpeg advanced packing") );
  item33->Add( item35, 0, wxALIGN_CENTRE|wxALL, 5 );

  item29->Add( item33, 0, wxALIGN_CENTRE|wxALL, 0 );

  item28->Add( item29, 0, wxALIGN_CENTRE|wxALL, 0 );

  item21->Add( item28, 0, wxALIGN_CENTRE|wxALL, 5 );

  item20->Add( item21, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticBox *item37 = new wxStaticBox( parent, -1, _("Color correction") );
  wxStaticBoxSizer *item36 = new wxStaticBoxSizer( item37, wxVERTICAL );

  wxCheckBox *item38 = new wxCheckBox( parent, ID_CHECKBOX, _("Modify colors"), wxDefaultPosition, wxDefaultSize, 0 );
  item38->SetToolTip( _("Use panorama tools color correction") );
  item36->Add( item38, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item39 = new wxStaticText( parent, ID_TEXT, _("Reference image type:"), wxDefaultPosition, wxDefaultSize, 0 );
  item36->Add( item39, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxString strs40[] = 
  {
    _("not in use")
  };
  wxComboBox *item40 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(260,-1), 1, strs40, wxCB_DROPDOWN );
  item40->SetToolTip( _("Wich image is reference") );
  item36->Add( item40, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxStaticText *item41 = new wxStaticText( parent, ID_TEXT, _("Correction type:"), wxDefaultPosition, wxDefaultSize, 0 );
  item36->Add( item41, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxString strs42[] = 
  {
    _("not in use"), 
     _("Correct both brightness and color (k)"), 
     _("Correct brightness (k)"), 
     _("Correct color (k)")
  };
  wxComboBox *item42 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(260,-1), 4, strs42, wxCB_DROPDOWN );
  item42->SetToolTip( _("Type of correction") );
  item36->Add( item42, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item36->Add( 20, 10, 0, wxALIGN_CENTRE|wxALL, 5 );

  item20->Add( item36, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  item2->Add( item20, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item0->Add( item2, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  if (set_sizer)
  {
    parent->SetAutoLayout( TRUE );
    parent->SetSizer( item0 );
    if (call_fit)
    {
      item0->Fit( parent );
      item0->SetSizeHints( parent );
    }
  }

  return item0;
}

wxSizer *Page4Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
  wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item1 = new wxStaticText( parent, ID_TEXT, 
    _("Current status for image positions and correction factor. * means that parameter is/will be optimized. (0) value is linked to first image.\n"
    "Hint: Click cell and then right clock for popup-menu. Operation is for selected cell."),
    wxDefaultPosition, wxDefaultSize, 0 );
  item0->Add( item1, 0, wxALIGN_CENTRE|wxALL, 5 );

/*  wxListCtrl *item2 = new wxListCtrl( parent, ID_LISTCTRL, wxDefaultPosition, wxSize(160,120), wxLC_REPORT|wxSUNKEN_BORDER );
  item2->SetToolTip( _("Image parameters") );
  item0->Add( item2, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );
*/
  wxListCtrl *imparam_list = new wxListCtrl( parent, ID_LISTCTRL, wxDefaultPosition, wxSize(160,120), wxLC_REPORT|wxSUNKEN_BORDER );
  imparam_list->SetToolTip( _("image parameters") );
  item0->Add( imparam_list, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );
  imparam_list->InsertColumn( 0, _("#"), wxLIST_FORMAT_LEFT, 25 );
  imparam_list->InsertColumn( 1, _("Filename"), wxLIST_FORMAT_LEFT, 270 );
  imparam_list->InsertColumn( 2, _("yaw (y)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 3, _("pitch (p)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 4, _("roll (r)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 5, _("a"), wxLIST_FORMAT_LEFT, 40 );
  imparam_list->InsertColumn( 6, _("b"), wxLIST_FORMAT_LEFT, 40 );
  imparam_list->InsertColumn( 7, _("c"), wxLIST_FORMAT_LEFT, 40 );
  imparam_list->InsertColumn( 8, _("horiz. (d)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 9, _("vert. (e)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 10, _("shear x (g)"), wxLIST_FORMAT_LEFT, 60 );
  imparam_list->InsertColumn( 11, _("shear y (t)"), wxLIST_FORMAT_LEFT, 60 );
  // Here comes an sample entry 
  wxString buf;
  int filenumber;
  filenumber=0;
  buf.Printf( _("%d"), filenumber);
  imparam_list->InsertItem(0, buf, 0);
  buf.Printf( _("--------"));
  imparam_list->SetItem(0, 1, buf);
  buf.Printf( _("%d"), filenumber);
  imparam_list->SetItem(0, 2, buf);
  imparam_list->SetItem(0, 3, buf);
  imparam_list->SetItem(0, 4, buf);

  wxBoxSizer *item3 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item4 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item5 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item6 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item7 = new wxStaticText( parent, ID_TEXT, _("Predefined optimizations"), wxDefaultPosition, wxDefaultSize, 0 );
  item6->Add( item7, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5 );

  wxString strs8[] = 
  {
    _("No change"), 
    _("Start (y,p,r)"), 
    _("Basic (y,p,r,b0,d0,e0)"), 
    _("First as reference [y,p,r.*,a-d:(0)]"), 
    _("All but selected line untouched")
  };
  wxComboBox *item8 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(220,-1), 5, strs8, wxCB_DROPDOWN );
  item8->SetToolTip( _("Basic might be an good starting point") );
  item6->Add( item8, 0, wxALIGN_CENTER_VERTICAL, 5 );

  item5->Add( item6, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL|wxALL, 0 );

  wxBoxSizer *item9 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item10 = new wxStaticText( parent, ID_TEXT, _("Data of last selection"), wxDefaultPosition, wxDefaultSize, 0 );
  item9->Add( item10, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5 );

  wxTextCtrl *item11 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(110,-1), 0 );
  item11->SetToolTip( _("Edit image parameter") );
  item9->Add( item11, 0, wxALIGN_CENTER_VERTICAL, 0 );

  item5->Add( item9, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL|wxLEFT, 5 );

  wxButton *item12 = new wxButton( parent, ID_BUTTON, _("Update"), wxDefaultPosition, wxDefaultSize, 0 );
  item5->Add( item12, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL, 5 );

  item4->Add( item5, 0, wxALIGN_CENTER_VERTICAL, 5 );

  wxBoxSizer *item13 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item14 = new wxBoxSizer( wxVERTICAL );

  wxButton *item15 = new wxButton( parent, ID_BUTTON, _("Slice optimization"), wxDefaultPosition, wxSize(150,-1), 0 );
  item15->SetToolTip( _("Optimize one column at one time") );
  item14->Add( item15, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP, 5 );

  wxButton *item16 = new wxButton( parent, ID_BUTTON, _("Slice in loop run"), wxDefaultPosition, wxSize(150,-1), 0 );
  item16->SetToolTip( _("Run optimization until results keep the same") );
  item14->Add( item16, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0 );

  item13->Add( item14, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL|wxALL, 0 );

  wxBoxSizer *item17 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item18 = new wxStaticText( parent, ID_TEXT, _("loop change"), wxDefaultPosition, wxDefaultSize, 0 );
  item17->Add( item18, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item19 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0.01"), wxDefaultPosition, wxSize(80,-1), 0 );
  item19->SetToolTip( _("Minimum change in result") );
  item17->Add( item19, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

  item13->Add( item17, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL, 5 );

  wxBoxSizer *item20 = new wxBoxSizer( wxVERTICAL );

  wxStaticText *item21 = new wxStaticText( parent, ID_TEXT, _("Max seconds"), wxDefaultPosition, wxDefaultSize, 0 );
  item20->Add( item21, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxTextCtrl *item22 = new wxTextCtrl( parent, ID_TEXTCTRL, _("300"), wxDefaultPosition, wxSize(80,-1), 0 );
  item22->SetToolTip( _("Max time in seconds for loop") );
  item20->Add( item22, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

  item13->Add( item20, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL|wxRIGHT, 5 );

  wxButton *item23 = new wxButton( parent, ID_BUTTON, _("Stop loop"), wxDefaultPosition, wxDefaultSize, 0 );
  item23->SetToolTip( _("Do not make new calls. Use chancel for current call.") );
  item13->Add( item23, 0, wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxTOP, 5 );

  item4->Add( item13, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxLEFT|wxTOP|wxBOTTOM, 0 );

  item3->Add( item4, 0, wxALIGN_CENTER_HORIZONTAL, 5 );

  wxStaticBox *item25 = new wxStaticBox( parent, -1, _("Default settings") );
  wxStaticBoxSizer *item24 = new wxStaticBoxSizer( item25, wxVERTICAL );

  wxBoxSizer *item26 = new wxBoxSizer( wxHORIZONTAL );

  wxButton *item27 = new wxButton( parent, ID_BUTTON, _("Clear opt"), wxDefaultPosition, wxDefaultSize, 0 );
  item27->SetToolTip( _("Set all optimized values to zero (except hfov), starts optimization from zero") );
  item26->Add( item27, 0, wxALIGN_CENTRE, 5 );

  wxButton *item28 = new wxButton( parent, ID_BUTTON, _("Memorize"), wxDefaultPosition, wxDefaultSize, 0 );
  item28->SetToolTip( _("Set current optimization result to be fetched later. Store optimization parameters also.") );
  item26->Add( item28, 0, wxALIGN_CENTRE, 5 );

  wxButton *item29 = new wxButton( parent, ID_BUTTON, _("Take back"), wxDefaultPosition, wxDefaultSize, 0 );
  item29->SetToolTip( _("Set previous stored values to current status. Control point values are keept untouched.") );
  item26->Add( item29, 0, wxALIGN_CENTRE, 5 );

  item24->Add( item26, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxButton *item30 = new wxButton( parent, ID_BUTTON, _("Swap"), wxDefaultPosition, wxDefaultSize, 0 );
  item30->SetToolTip( _("Swap current status and memorized status") );
  item24->Add( item30, 0, wxALIGN_CENTRE|wxALL, 10 );

  item3->Add( item24, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

  item0->Add( item3, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  if (set_sizer)
  {
    parent->SetAutoLayout( TRUE );
    parent->SetSizer( item0 );
    if (call_fit)
    {
      item0->Fit( parent );
      item0->SetSizeHints( parent );
    }
 }
    
  return item0;
}

wxSizer *Page5Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
  wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item1 = new wxBoxSizer( wxHORIZONTAL );

  wxScrolledWindow *item2 = new wxScrolledWindow( parent, ID_SCROLLED, wxDefaultPosition, wxSize(395,300), wxHSCROLL|wxVSCROLL );
  item2->SetScrollbars( 10, 10, 20, 100, 0, 0 );
  item2->SetToolTip( _("Left image") );
  item1->Add( item2, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxScrolledWindow *item3 = new wxScrolledWindow( parent, ID_SCROLLED, wxDefaultPosition, wxSize(395,300), wxHSCROLL|wxVSCROLL );
  item3->SetScrollbars( 10, 10, 20, 100, 0, 0 );
  item3->SetToolTip( _("Right image") );
  item1->Add( item3, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxRIGHT|wxTOP, 5 );

  item0->Add( item1, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

  wxBoxSizer *item4 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item5 = new wxBoxSizer( wxVERTICAL );

  wxListCtrl *item6 = new wxListCtrl( parent, ID_LISTCTRL, wxDefaultPosition, wxSize(390,120), wxLC_REPORT|wxSUNKEN_BORDER );
  item6->SetToolTip( _("Control point data") );
  item5->Add( item6, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5 );

  wxBoxSizer *item7 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item8 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item9 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item10 = new wxStaticText( parent, ID_TEXT, _("Coord"), wxDefaultPosition, wxDefaultSize, 0 );
  item9->Add( item10, 0, wxALIGN_CENTRE|wxRIGHT|wxTOP|wxBOTTOM, 5 );

  wxTextCtrl *item11 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(30,-1), 0 );
  item11->SetToolTip( _("Left image X coordinate") );
  item9->Add( item11, 0, wxALIGN_CENTRE, 5 );

  wxTextCtrl *item12 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(30,-1), 0 );
  item12->SetToolTip( _("Left image Y coordinate") );
  item9->Add( item12, 0, wxALIGN_CENTRE, 5 );

  wxTextCtrl *item13 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(30,-1), 0 );
  item13->SetToolTip( _("Right image X coordinate") );
  item9->Add( item13, 0, wxALIGN_CENTRE, 5 );

  wxTextCtrl *item14 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxSize(30,-1), 0 );
  item14->SetToolTip( _("Right image Y coordinate") );
  item9->Add( item14, 0, wxALIGN_CENTRE, 5 );

  item8->Add( item9, 0, wxALIGN_CENTER_VERTICAL|wxBOTTOM, 5 );

  wxBoxSizer *item15 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item16 = new wxStaticText( parent, ID_TEXT, _("       "), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item16, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item17 = new wxStaticText( parent, ID_TEXT, _("lX "), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item17, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item18 = new wxStaticText( parent, ID_TEXT, _(" lY "), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item18, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item19 = new wxStaticText( parent, ID_TEXT, _(" rX "), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item19, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item20 = new wxStaticText( parent, ID_TEXT, _(" rY "), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item20, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxStaticText *item21 = new wxStaticText( parent, ID_TEXT, _("Line Nr."), wxDefaultPosition, wxDefaultSize, 0 );
  item15->Add( item21, 0, wxALIGN_CENTRE|wxALL, 5 );

  item8->Add( item15, 0, wxALIGN_CENTER_VERTICAL, 5 );

  wxBoxSizer *item22 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item23 = new wxStaticText( parent, ID_TEXT, _("Comment"), wxDefaultPosition, wxDefaultSize, 0 );
  item22->Add( item23, 0, wxALIGN_CENTRE|wxALL, 5 );

  wxTextCtrl *item24 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(80,-1), 0 );
  item24->SetToolTip( _("Comment for control point") );
  item22->Add( item24, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxString strs25[] = 
  {
    _("New")
  };
  wxComboBox *item25 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(60,-1), 1, strs25, wxCB_DROPDOWN );
  item25->SetToolTip( _("Number of line. (set same line numbers for at least two control point numbers)") );
  item22->Add( item25, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  item8->Add( item22, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5 );

  item7->Add( item8, 0, wxALIGN_CENTRE, 5 );

  wxStaticBox *item27 = new wxStaticBox( parent, -1, _("Align (t)") );
  wxStaticBoxSizer *item26 = new wxStaticBoxSizer( item27, wxVERTICAL );

  wxRadioButton *item28 = new wxRadioButton( parent, ID_RADIOBUTTON, _("H+V"), wxDefaultPosition, wxDefaultSize, 0 );
  item28->SetToolTip( _("Control point type, default is H+V (= horizontal'-' + vertical '|' )") );
  item26->Add( item28, 0, wxALIGN_CENTER_VERTICAL, 0 );

  wxRadioButton *item29 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Ver"), wxDefaultPosition, wxDefaultSize, 0 );
  item29->SetToolTip( _("Control point type - for vertical alignment") );
  item26->Add( item29, 0, wxALIGN_CENTER_VERTICAL, 0 );

  wxRadioButton *item30 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Hor"), wxDefaultPosition, wxDefaultSize, 0 );
  item30->SetToolTip( _("Control point type - for horizontal alignment") );
  item26->Add( item30, 0, wxALIGN_CENTER_VERTICAL, 0 );

  wxRadioButton *item31 = new wxRadioButton( parent, ID_RADIOBUTTON, _("Line"), wxDefaultPosition, wxDefaultSize, 0 );
  item31->SetToolTip( _("Control points type - for straighten of lens distorted lines") );
  item26->Add( item31, 0, wxALIGN_CENTER_VERTICAL, 0 );

  item7->Add( item26, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT, 5 );

  wxBoxSizer *item32 = new wxBoxSizer( wxVERTICAL );

  wxBoxSizer *item33 = new wxBoxSizer( wxHORIZONTAL );

  wxButton *item34 = new wxButton( parent, ID_BUTTON, _("Add"), wxDefaultPosition, wxSize(50,-1), 0 );
  item34->SetToolTip( _("Add new control point") );
  item33->Add( item34, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxButton *item35 = new wxButton( parent, ID_BUTTON, _("Delete"), wxDefaultPosition, wxSize(50,-1), 0 );
  item35->SetToolTip( _("Delete selected control point") );
  item33->Add( item35, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxString strs36[] = 
  {
    _("100%"), 
    _("70,7%"), 
    _("50%"), 
    _("33,3%"), 
    _("25%"), 
    _("20%"), 
    _("16,5%"), 
    _("14,3%"), 
    _("12,5%"), 
    _("10%")
  };
  wxComboBox *item36 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(70,-1), 10, strs36, wxCB_DROPDOWN );
  item36->SetToolTip( _("Main window zoom") );
  item33->Add( item36, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  item32->Add( item33, 0, wxALIGN_CENTRE, 5 );

  wxBoxSizer *item37 = new wxBoxSizer( wxHORIZONTAL );

  wxStaticText *item38 = new wxStaticText( parent, ID_TEXT, _("Zoom by "), wxDefaultPosition, wxDefaultSize, 0 );
  item37->Add( item38, 0, wxALIGN_CENTRE, 5 );

  item32->Add( item37, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5 );

  wxBoxSizer *item39 = new wxBoxSizer( wxHORIZONTAL );

  wxButton *item40 = new wxButton( parent, ID_BUTTON, _("Update"), wxDefaultPosition, wxSize(50,-1), 0 );
  item40->SetToolTip( _("Update selected line") );
  item39->Add( item40, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxButton *item41 = new wxButton( parent, ID_BUTTON, _("Search"), wxDefaultPosition, wxSize(50,-1), 0 );
  item41->SetToolTip( _("Tries to find best position for current control point. Check result and if nor correct use interactive menu...") );
  item39->Add( item41, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxString strs42[] = 
  {
    _("1"), 
    _("2"), 
    _("3"), 
    _("4"), 
    _("5"), 
    _("6"), 
    _("8"), 
    _("10"), 
    _("12"), 
    _("14"), 
    _("16"), 
    _("20"), 
    _("30"), 
    _("40"), 
    _("50")
  };
  wxComboBox *item42 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(70,-1), 15, strs42, wxCB_DROPDOWN );
  item42->SetToolTip( _("Small \"finetune\" window zoom") );
  item39->Add( item42, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  item32->Add( item39, 0, wxALIGN_CENTRE, 5 );

  item7->Add( item32, 0, wxALIGN_CENTER_HORIZONTAL|wxBOTTOM, 5 );

  item5->Add( item7, 0, wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5 );

  item4->Add( item5, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

  wxBoxSizer *item43 = new wxBoxSizer( wxHORIZONTAL );

  wxBoxSizer *item44 = new wxBoxSizer( wxVERTICAL );

  wxPanel *item45 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(167,200), 0 );
  item45->SetToolTip( _("left zoom image") );
  item44->Add( item45, 0, wxALIGN_CENTRE, 5 );

  wxStaticText *item46 = new wxStaticText( parent, ID_TEXT, _("text"), wxDefaultPosition, wxDefaultSize, 0 );
  item44->Add( item46, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

  item43->Add( item44, 0, wxALIGN_CENTRE|wxLEFT, 5 );

  wxBoxSizer *item47 = new wxBoxSizer( wxVERTICAL );

  wxPanel *item48 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(167,200), 0 );
  item48->SetToolTip( _("right zoom image") );
  item47->Add( item48, 0, wxALIGN_CENTRE, 5 );

  wxStaticText *item49 = new wxStaticText( parent, ID_TEXT, _("text"), wxDefaultPosition, wxDefaultSize, 0 );
  item47->Add( item49, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

  item43->Add( item47, 0, wxALIGN_CENTRE, 5 );

  item4->Add( item43, 0, wxALIGN_CENTRE, 5 );

  item0->Add( item4, 0, wxALIGN_CENTRE|wxRIGHT|wxBOTTOM, 5 );

  if (set_sizer)
  {
    parent->SetAutoLayout( TRUE );
    parent->SetSizer( item0 );
    if (call_fit)
    {
      item0->Fit( parent );
      item0->SetSizeHints( parent );
    }
  }
    
  return item0;
}

wxSizer *Page6Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

    wxBoxSizer *item1 = new wxBoxSizer( wxHORIZONTAL );

    wxStaticText *item2 = new wxStaticText( parent, ID_TEXT, 
        _("Left check box is to optimize parameter\n"
        "Middle box links value to reference image\n"
        "Right box os number where this references"),
        wxDefaultPosition, wxDefaultSize, 0 );
    item1->Add( item2, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item3 = new wxButton( parent, ID_BUTTON, _("Optimize image positions"), wxDefaultPosition, wxDefaultSize, 0 );
    item3->SetToolTip( _("Optimize project with given parameters") );
    item1->Add( item3, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

    item1->Add( 20, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item4 = new wxButton( parent, ID_BUTTON, _("Reset script"), wxDefaultPosition, wxDefaultSize, 0 );
    item4->SetToolTip( _("Shows and set script") );
    item1->Add( item4, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item5 = new wxButton( parent, ID_BUTTON, _("Show script"), wxDefaultPosition, wxDefaultSize, 0 );
    item1->Add( item5, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item6 = new wxBoxSizer( wxVERTICAL );

    wxCheckBox *item7 = new wxCheckBox( parent, ID_CHECKBOX, _("Background optimize"), wxDefaultPosition, wxDefaultSize, 0 );
    item7->SetValue( TRUE );
    item7->SetToolTip( _("Run optimization when an control point has been changed") );
    item6->Add( item7, 0, wxALIGN_CENTER_VERTICAL, 5 );

    wxCheckBox *item8 = new wxCheckBox( parent, ID_CHECKBOX, _("Use written script"), wxDefaultPosition, wxDefaultSize, 0 );
    item8->Enable( FALSE );
    item6->Add( item8, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0 );

    item1->Add( item6, 0, wxALIGN_CENTRE|wxALL, 5 );

    item0->Add( item1, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxBoxSizer *item9 = new wxBoxSizer( wxHORIZONTAL );

    wxBoxSizer *item10 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item11 = new wxStaticText( parent, ID_TEXT, _("Yaw (y)"), wxDefaultPosition, wxDefaultSize, 0 );
    item10->Add( item11, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item12 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item10->Add( item12, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item13 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item14 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item14->SetToolTip( _("Set optimization for all (y)") );
    item13->Add( item14, 0, wxALIGN_CENTRE, 5 );

    wxButton *item15 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item15->SetToolTip( _("Clear optimize for all (y)") );
    item13->Add( item15, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item16 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item16->SetToolTip( _("Set link for all (y)") );
    item13->Add( item16, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item17 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item17->SetToolTip( _("Clear link for all (y)") );
    item13->Add( item17, 0, wxALIGN_CENTRE|wxALL, 0 );

    item10->Add( item13, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item10, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item18 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item19 = new wxStaticText( parent, ID_TEXT, _("Pitch (p)"), wxDefaultPosition, wxDefaultSize, 0 );
    item18->Add( item19, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item20 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item18->Add( item20, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item21 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item22 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item22->SetToolTip( _("Set optimization for all (p)") );
    item21->Add( item22, 0, wxALIGN_CENTRE, 5 );

    wxButton *item23 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item23->SetToolTip( _("Clear optimize for all (y)") );
    item21->Add( item23, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item24 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item24->SetToolTip( _("Set link for all (y)") );
    item21->Add( item24, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item25 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item25->SetToolTip( _("Clear link for all (y)") );
    item21->Add( item25, 0, wxALIGN_CENTRE|wxALL, 0 );

    item18->Add( item21, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item18, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item26 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item27 = new wxStaticText( parent, ID_TEXT, _("Roll (r)"), wxDefaultPosition, wxDefaultSize, 0 );
    item26->Add( item27, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item28 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item26->Add( item28, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item29 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item30 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item30->SetToolTip( _("Set optimization for all (y)") );
    item29->Add( item30, 0, wxALIGN_CENTRE, 5 );

    wxButton *item31 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item31->SetToolTip( _("Clear optimize for all (y)") );
    item29->Add( item31, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item32 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item32->SetToolTip( _("Set link for all (y)") );
    item29->Add( item32, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item33 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item33->SetToolTip( _("Clear link for all (y)") );
    item29->Add( item33, 0, wxALIGN_CENTRE|wxALL, 0 );

    item26->Add( item29, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item26, 0, wxALIGN_CENTRE|wxRIGHT, 5 );

    wxBoxSizer *item34 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item35 = new wxStaticText( parent, ID_TEXT, _("Hfov (v)"), wxDefaultPosition, wxDefaultSize, 0 );
    item35->SetToolTip( _("Horizontal field of view") );
    item34->Add( item35, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item36 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item34->Add( item36, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item37 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item38 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item38->SetToolTip( _("Set optimization for all (y)") );
    item37->Add( item38, 0, wxALIGN_CENTRE, 5 );

    wxButton *item39 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item39->SetToolTip( _("Clear optimize for all (y)") );
    item37->Add( item39, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item40 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item40->SetToolTip( _("Set link for all (y)") );
    item37->Add( item40, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item41 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item41->SetToolTip( _("Clear link for all (y)") );
    item37->Add( item41, 0, wxALIGN_CENTRE|wxALL, 0 );

    item34->Add( item37, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item34, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item42 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item43 = new wxStaticText( parent, ID_TEXT, _("Lens A (a)"), wxDefaultPosition, wxDefaultSize, 0 );
    item43->SetToolTip( _("Lens distortion factor a") );
    item42->Add( item43, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item44 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item42->Add( item44, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item45 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item46 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item46->SetToolTip( _("Set optimization for all (y)") );
    item45->Add( item46, 0, wxALIGN_CENTRE, 5 );

    wxButton *item47 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item47->SetToolTip( _("Clear optimize for all (y)") );
    item45->Add( item47, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item48 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item48->SetToolTip( _("Set link for all (y)") );
    item45->Add( item48, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item49 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item49->SetToolTip( _("Clear link for all (y)") );
    item45->Add( item49, 0, wxALIGN_CENTRE|wxALL, 0 );

    item42->Add( item45, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item42, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item50 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item51 = new wxStaticText( parent, ID_TEXT, _("Lens B (b)"), wxDefaultPosition, wxDefaultSize, 0 );
    item51->SetToolTip( _("Lens distortion factor b") );
    item50->Add( item51, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item52 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item50->Add( item52, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item53 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item54 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item54->SetToolTip( _("Set optimization for all (y)") );
    item53->Add( item54, 0, wxALIGN_CENTRE, 5 );

    wxButton *item55 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item55->SetToolTip( _("Clear optimize for all (y)") );
    item53->Add( item55, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item56 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item56->SetToolTip( _("Set link for all (y)") );
    item53->Add( item56, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item57 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item57->SetToolTip( _("Clear link for all (y)") );
    item53->Add( item57, 0, wxALIGN_CENTRE|wxALL, 0 );

    item50->Add( item53, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item50, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item58 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item59 = new wxStaticText( parent, ID_TEXT, _("Lens C (c)"), wxDefaultPosition, wxDefaultSize, 0 );
    item59->SetToolTip( _("Lens distortion factor c") );
    item58->Add( item59, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item60 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item58->Add( item60, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item61 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item62 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item62->SetToolTip( _("Set optimization for all (y)") );
    item61->Add( item62, 0, wxALIGN_CENTRE, 5 );

    wxButton *item63 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item63->SetToolTip( _("Clear optimize for all (y)") );
    item61->Add( item63, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item64 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item64->SetToolTip( _("Set link for all (y)") );
    item61->Add( item64, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item65 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item65->SetToolTip( _("Clear link for all (y)") );
    item61->Add( item65, 0, wxALIGN_CENTRE|wxALL, 0 );

    item58->Add( item61, 0, wxALIGN_CENTRE|wxALL, 5 );

    item9->Add( item58, 0, wxALIGN_CENTRE, 5 );

    item0->Add( item9, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxBoxSizer *item66 = new wxBoxSizer( wxHORIZONTAL );

    wxBoxSizer *item67 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item68 = new wxStaticText( parent, ID_TEXT, _("Used control points"), wxDefaultPosition, wxDefaultSize, 0 );
    item67->Add( item68, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxPanel *item69 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item67->Add( item69, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item70 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item71 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item71->SetToolTip( _("Set selection for all") );
    item70->Add( item71, 0, wxALIGN_CENTRE, 5 );

    wxButton *item72 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item72->SetToolTip( _("Clear selection") );
    item70->Add( item72, 0, wxALIGN_CENTRE|wxALL, 0 );

    item67->Add( item70, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item66->Add( item67, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item73 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item74 = new wxStaticText( parent, ID_TEXT, _("Select reference image:"), wxDefaultPosition, wxDefaultSize, 0 );
    item73->Add( item74, 0, wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5 );

    wxString strs75[] = 
    {
        _("no reference")
    };
    wxComboBox *item75 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(203,-1), 1, strs75, wxCB_DROPDOWN );
    item73->Add( item75, 0, wxALIGN_CENTRE|wxTOP|wxBOTTOM, 5 );

    item66->Add( item73, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item76 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item77 = new wxStaticText( parent, ID_TEXT, _("Hor shift (d)"), wxDefaultPosition, wxDefaultSize, 0 );
    item76->Add( item77, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item78 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item76->Add( item78, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item79 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item80 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item80->SetToolTip( _("Set optimization for all (y)") );
    item79->Add( item80, 0, wxALIGN_CENTRE, 5 );

    wxButton *item81 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item81->SetToolTip( _("Clear optimize for all (y)") );
    item79->Add( item81, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item82 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item82->SetToolTip( _("Set link for all (y)") );
    item79->Add( item82, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item83 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item83->SetToolTip( _("Clear link for all (y)") );
    item79->Add( item83, 0, wxALIGN_CENTRE|wxALL, 0 );

    item76->Add( item79, 0, wxALIGN_CENTRE|wxALL, 5 );

    item66->Add( item76, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item84 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item85 = new wxStaticText( parent, ID_TEXT, _("Vert shift (e)"), wxDefaultPosition, wxDefaultSize, 0 );
    item84->Add( item85, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item86 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item84->Add( item86, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item87 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item88 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item88->SetToolTip( _("Set optimization for all (y)") );
    item87->Add( item88, 0, wxALIGN_CENTRE, 5 );

    wxButton *item89 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item89->SetToolTip( _("Clear optimize for all (y)") );
    item87->Add( item89, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item90 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item90->SetToolTip( _("Set link for all (y)") );
    item87->Add( item90, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item91 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item91->SetToolTip( _("Clear link for all (y)") );
    item87->Add( item91, 0, wxALIGN_CENTRE|wxALL, 0 );

    item84->Add( item87, 0, wxALIGN_CENTRE|wxALL, 5 );

    item66->Add( item84, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item92 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item93 = new wxStaticText( parent, ID_TEXT, _("Hor shear (g)"), wxDefaultPosition, wxDefaultSize, 0 );
    item92->Add( item93, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item94 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item92->Add( item94, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item95 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item96 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item96->SetToolTip( _("Set optimization for all (y)") );
    item95->Add( item96, 0, wxALIGN_CENTRE, 5 );

    wxButton *item97 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item97->SetToolTip( _("Clear optimize for all (y)") );
    item95->Add( item97, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item98 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item98->SetToolTip( _("Set link for all (y)") );
    item95->Add( item98, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item99 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item99->SetToolTip( _("Clear link for all (y)") );
    item95->Add( item99, 0, wxALIGN_CENTRE|wxALL, 0 );

    item92->Add( item95, 0, wxALIGN_CENTRE|wxALL, 5 );

    item66->Add( item92, 0, wxALIGN_CENTRE, 5 );

    wxBoxSizer *item100 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item101 = new wxStaticText( parent, ID_TEXT, _("Vert shear (t)"), wxDefaultPosition, wxDefaultSize, 0 );
    item100->Add( item101, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxPanel *item102 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(98,130), wxSUNKEN_BORDER );
    item100->Add( item102, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxBoxSizer *item103 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item104 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(23,20), 0 );
    item104->SetToolTip( _("Set optimization for all (y)") );
    item103->Add( item104, 0, wxALIGN_CENTRE, 5 );

    wxButton *item105 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(22,20), 0 );
    item105->SetToolTip( _("Clear optimize for all (y)") );
    item103->Add( item105, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item106 = new wxButton( parent, ID_BUTTON, _("Set"), wxDefaultPosition, wxSize(22,20), 0 );
    item106->SetToolTip( _("Set link for all (y)") );
    item103->Add( item106, 0, wxALIGN_CENTRE|wxALL, 0 );

    wxButton *item107 = new wxButton( parent, ID_BUTTON, _("Clr"), wxDefaultPosition, wxSize(23,20), 0 );
    item107->SetToolTip( _("Clear link for all (y)") );
    item103->Add( item107, 0, wxALIGN_CENTRE|wxALL, 0 );

    item100->Add( item103, 0, wxALIGN_CENTRE|wxALL, 5 );

    item66->Add( item100, 0, wxALIGN_CENTRE, 5 );

    item0->Add( item66, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    if (set_sizer)
    {
        parent->SetAutoLayout( TRUE );
        parent->SetSizer( item0 );
        if (call_fit)
        {
            item0->Fit( parent );
            item0->SetSizeHints( parent );
        }
    }
    
    return item0;
}

wxSizer *Page7Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxHORIZONTAL );

    wxBoxSizer *item1 = new wxBoxSizer( wxVERTICAL );

    wxBoxSizer *item2 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item3 = new wxButton( parent, ID_BUTTON, _("Edit script"), wxDefaultPosition, wxDefaultSize, 0 );
    item3->SetToolTip( _("Write default stitching to memo") );
    item2->Add( item3, 0, wxALIGN_CENTRE|wxALL, 5 );

    item2->Add( 20, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item4 = new wxButton( parent, ID_BUTTON, _("Make preview"), wxDefaultPosition, wxDefaultSize, 0 );
    item4->SetToolTip( _("Start preview stitching") );
    item2->Add( item4, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxCheckBox *item5 = new wxCheckBox( parent, ID_CHECKBOX, _("Auto preview update"), wxDefaultPosition, wxDefaultSize, 0 );
    item5->SetToolTip( _("???") );
    item2->Add( item5, 0, wxALIGN_CENTRE|wxALL, 5 );

    item1->Add( item2, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5 );

    wxTextCtrl *item6 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(400,520), wxTE_MULTILINE );
    item1->Add( item6, 0, wxALIGN_CENTRE|wxALL, 5 );

    item0->Add( item1, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

    wxBoxSizer *item7 = new wxBoxSizer( wxVERTICAL );

    wxStaticBox *item9 = new wxStaticBox( parent, -1, _("Size") );
    wxStaticBoxSizer *item8 = new wxStaticBoxSizer( item9, wxVERTICAL );

    wxStaticText *item10 = new wxStaticText( parent, ID_TEXT, _("Width"), wxDefaultPosition, wxDefaultSize, 0 );
    item8->Add( item10, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

    wxTextCtrl *item11 = new wxTextCtrl( parent, ID_TEXTCTRL, _("600"), wxDefaultPosition, wxSize(80,-1), 0 );
    item11->SetToolTip( _("Width of preview in pixel") );
    item8->Add( item11, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5 );

    wxStaticText *item12 = new wxStaticText( parent, ID_TEXT, _("Height"), wxDefaultPosition, wxDefaultSize, 0 );
    item8->Add( item12, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

    wxTextCtrl *item13 = new wxTextCtrl( parent, ID_TEXTCTRL, _("300"), wxDefaultPosition, wxSize(80,-1), 0 );
    item13->SetToolTip( _("Height of preview in pixel") );
    item13->Enable( FALSE );
    item8->Add( item13, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5 );

    wxCheckBox *item14 = new wxCheckBox( parent, ID_CHECKBOX, _("Proportional ratio"), wxDefaultPosition, wxDefaultSize, 0 );
    item14->SetValue( TRUE );
    item14->SetToolTip( _("Preserve ratio of 1:2 from height to width") );
    item8->Add( item14, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item7->Add( item8, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxStaticBox *item16 = new wxStaticBox( parent, -1, _("Stitch") );
    wxStaticBoxSizer *item15 = new wxStaticBoxSizer( item16, wxVERTICAL );

    wxStaticText *item17 = new wxStaticText( parent, ID_TEXT, _("Interpolator"), wxDefaultPosition, wxDefaultSize, 0 );
    item15->Add( item17, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

  wxString strs18[] = 
  {
    _("Same as panorama"),
    _("Nearest neighbour"), 
    _("Bilinear"), 
    _("Poly3 (Bicubic)"), 
    _("Spline 16"), 
    _("Spline 32"), 
    _("Spline 64"), 
    _("Sinc 256"), 
    _("Sinc 1024")
  };
    wxComboBox *item18 = new wxComboBox( parent, ID_COMBO, wxT(""), wxDefaultPosition, wxSize(140,-1), 9, strs18, wxCB_DROPDOWN );
    item18->SetToolTip( _("Preview interpolator") );
    item15->Add( item18, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

    wxCheckBox *item19 = new wxCheckBox( parent, ID_CHECKBOX, _("Proportional feather"), wxDefaultPosition, wxDefaultSize, 0 );
    item19->SetValue( TRUE );
    item15->Add( item19, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item7->Add( item15, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item0->Add( item7, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

    wxStaticBox *item21 = new wxStaticBox( parent, -1, _("Images") );
    wxStaticBoxSizer *item20 = new wxStaticBoxSizer( item21, wxVERTICAL );

    wxPanel *item22 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(140,220), 0 );
    item20->Add( item22, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item0->Add( item20, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxRIGHT|wxTOP|wxBOTTOM, 10 );

    if (set_sizer)
    {
        parent->SetAutoLayout( TRUE );
        parent->SetSizer( item0 );
        if (call_fit)
        {
            item0->Fit( parent );
            item0->SetSizeHints( parent );
        }
    }
    
    return item0;
}

wxSizer *Page8Func( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxVERTICAL );

    wxBoxSizer *item1 = new wxBoxSizer( wxHORIZONTAL );

    wxBoxSizer *item2 = new wxBoxSizer( wxVERTICAL );

    wxBoxSizer *item3 = new wxBoxSizer( wxHORIZONTAL );

    wxButton *item4 = new wxButton( parent, ID_BUTTON, _("Show stitch script"), wxDefaultPosition, wxDefaultSize, 0 );
    item4->SetToolTip( _("Show script in this window") );
    item3->Add( item4, 0, wxALIGN_CENTRE|wxALL, 5 );

    item3->Add( 80, 20, 0, wxALIGN_CENTRE|wxALL, 5 );

    wxButton *item5 = new wxButton( parent, ID_BUTTON, _("Hide script"), wxDefaultPosition, wxDefaultSize, 0 );
    item3->Add( item5, 0, wxALIGN_CENTRE|wxALL, 5 );

    item2->Add( item3, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxBOTTOM, 5 );

    wxStaticText *item6 = new wxStaticText( parent, ID_TEXT, 
        _("Set panorama options in text window\n"
        "P-line could look like:  p f0 h1000 w2000 v90 JPEG q90 u20 k0"),
        wxDefaultPosition, wxDefaultSize, 0 );
    item2->Add( item6, 0, wxALIGN_CENTRE|wxLEFT|wxRIGHT|wxTOP, 5 );

    item1->Add( item2, 0, wxALIGN_CENTRE|wxRIGHT|wxTOP|wxBOTTOM, 5 );

    wxButton *item7 = new wxButton( parent, ID_BUTTON, _("Stitch images"), wxDefaultPosition, wxSize(160,-1), 0 );
    item1->Add( item7, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

    item1->Add( 20, 20, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

    wxBoxSizer *item8 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item9 = new wxStaticText( parent, ID_TEXT, _("Output name"), wxDefaultPosition, wxDefaultSize, 0 );
    item8->Add( item9, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

    wxTextCtrl *item10 = new wxTextCtrl( parent, ID_TEXTCTRL, _("test"), wxDefaultPosition, wxDefaultSize, 0 );
    item10->SetToolTip( _("Name of resulting panorama file") );
    item8->Add( item10, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5 );

    item1->Add( item8, 0, wxALIGN_CENTRE|wxALL, 5 );

    item0->Add( item1, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5 );

    wxBoxSizer *item11 = new wxBoxSizer( wxHORIZONTAL );

    wxStaticBox *item13 = new wxStaticBox( parent, -1, _("Images") );
    wxStaticBoxSizer *item12 = new wxStaticBoxSizer( item13, wxVERTICAL );

    wxPanel *item14 = new wxPanel( parent, ID_PANEL, wxDefaultPosition, wxSize(140,-1), 0 );
    item12->Add( item14, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    item11->Add( item12, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxTOP|wxBOTTOM, 10 );

    wxTextCtrl *item15 = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(580,460), wxTE_MULTILINE|wxVSCROLL|wxHSCROLL );
    item11->Add( item15, 0, wxGROW|wxALIGN_CENTER_HORIZONTAL|wxALL, 10 );

    item0->Add( item11, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    if (set_sizer)
    {
        parent->SetAutoLayout( TRUE );
        parent->SetSizer( item0 );
        if (call_fit)
        {
            item0->Fit( parent );
            item0->SetSizeHints( parent );
        }
    }
    
    return item0;
}

wxSizer *ProjectEditFunc( wxWindow *parent, bool call_fit, bool set_sizer )
{
    wxBoxSizer *item0 = new wxBoxSizer( wxHORIZONTAL );

    wxTextCtrl *text_win = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(550,-1), wxTE_MULTILINE|wxVSCROLL|wxHSCROLL );
    item0->Add( text_win, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxTOP|wxBOTTOM, 5 );

    wxBoxSizer *item2 = new wxBoxSizer( wxVERTICAL );

    wxStaticText *item3 = new wxStaticText( parent, ID_TEXT, 
        _("Editor in expert mode\n"
        "\n"
        "Line Nr."),
        wxDefaultPosition, wxDefaultSize, 0 );
    item2->Add( item3, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5 );

    wxTextCtrl *item4 = new wxTextCtrl( parent, ID_TEXTCTRL, _("0"), wxDefaultPosition, wxDefaultSize, wxTE_READONLY );
//    item4->Enable( FALSE );
    item2->Add( item4, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5 );

    wxButton *item5 = new wxButton( parent, ID_BUTTON, _("Settings OK"), wxDefaultPosition, wxDefaultSize, 0 );
    item2->Add( item5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxButton *item6 = new wxButton( parent, ID_BUTTON, _("Close"), wxDefaultPosition, wxDefaultSize, 0 );
    item2->Add( item6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxStaticText *item7 = new wxStaticText( parent, ID_TEXT, 
        _("This text describes the \n"
        "current status of project.\n"
        "\n"
        "\n"
        "First error:"),
        wxDefaultPosition, wxDefaultSize, 0 );
    item2->Add( item7, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    wxTextCtrl *info_win = new wxTextCtrl( parent, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(-1,-1), wxTE_MULTILINE|wxVSCROLL );
    item2->Add( info_win, 0, wxGROW|wxRIGHT|wxTOP, 5 );

    item0->Add( item2, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5 );

    if (set_sizer)
    {
        parent->SetAutoLayout( TRUE );
        parent->SetSizer( item0 );
        if (call_fit)
        {
            item0->Fit( parent );
            item0->SetSizeHints( parent );
        }
    }
    
    return item0;
}




wxMenuBar *MainMenuBarFunc()
{
  wxMenuBar *item0 = new wxMenuBar;
    
  return item0;
}

