#ifndef __ptopengui_H__
#define __ptopengui_H__

#ifdef __GNUG__
  #pragma interface "ptopengui.h"
#endif


#ifndef WX_PRECOMP
  #include <wx/wx.h>
#endif
#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation
#pragma interface
#endif
#include "wx/intl.h"

// types from Panorama tools
#include "filter.h"

#include "ptopengui_parser.h"
/*   constants   */


#define ID_OPEN     100
#define ID_SAVE     101
#define ID_EDIT     102
#define ID_QUIT     103
#define ID_TEST     104
#define ID_ABOUT    105


/*   Classes   */

class MainFrame: public wxFrame
{
public:
  MainFrame( wxWindow* parent, wxWindowID id, const wxString &title,
	const wxPoint& pos/* = wxDefaultPosition*/,
	const wxSize& size/* = wxDefaultSize*/,
	long style/* = wxDEFAULT_FRAME_STYLE*/,
	wxLocale& m_locale );
    
public:
  void CreateMainMenuBar();
  void OnOpen( wxCommandEvent &event );
  void OnSave( wxCommandEvent &event );
  void OnEdit( wxCommandEvent &event );
  void OnTest( wxCommandEvent &event );
  void OnQuit( wxCommandEvent &event );
  void OnCloseWindow( wxCloseEvent &event );
  void OnAbout( wxCommandEvent &event );
  wxNotebook*     main_notebook;
  wxPanel*        main_panel; // Panel containing notebook and OK/Cancel/Help


  GuiAlignInfo Fainf;
  GuiAlignInfo Faopt;
  GuiAlignInfo Fapre;

  DECLARE_EVENT_TABLE()

  wxLocale& m_locale;
};


class PTOpenGui: public wxApp
{
public:
  PTOpenGui();

  virtual bool OnInit();
  virtual int OnExit();

protected:
    wxLocale m_locale; // locale we'll be using
};

#define ID_TEXTCTRL 10000
#define ID_CHECKBOX 10001
#define ID_BUTTON 10002
#define ID_NOTEBOOK 10003
#define ID_LINE 10004
#define ID_TEXT 10005
#define ID_LISTCTRL 10006
#define ID_PANEL 10007
#define ID_COMBO 10008
#define ID_RADIOBUTTON 10009
#define ID_SCROLLED 10010

wxSizer *DialogFunc( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page1Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page2Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page3Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page4Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page5Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page6Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page7Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *Page8Func( wxWindow *parent, bool call_fit = TRUE, bool set_sizer = TRUE );

wxSizer *ProjectEditFunc( wxWindow *parent, /*TProjectParser *parser, */bool call_fit = TRUE, bool set_sizer = TRUE);

wxMenuBar *MainMenuBarFunc();


#endif
