//---------------------------------------------------------------------------
#ifndef UnitParserH
#define UnitParserH
//---------------------------------------------------------------------------

// remove not needed later
#include "wx/wxprec.h"
#include <wx/image.h>
#include <wx/statline.h>
#include <wx/spinbutt.h>
#include <wx/spinctrl.h>
#include <wx/splitter.h>
#include <wx/listctrl.h>
#include <wx/treectrl.h>
#include <wx/notebook.h>
#include <wx/grid.h>

#include <wx/filename.h>
#ifdef __BORLANDC__
  #pragma hdrstop
#endif


#include "filter.h"

enum PrintTarget {
		PRINT_PROJECT,		// stored to disk
		PRINT_OPTIMIZE,		// PTOptimizer script
		PRINT_STITCH		// PTStitcher script
};
const int MAX_CP_TYPE_VALUE = 10000;	// there might not be need for this limit
//---------------------------------------------------------------------------

class TProjectParser
{
protected:
	wxTextCtrl *MemoScript;
	wxTextCtrl *EditLNr;
	wxTextCtrl *MemoErrors;
private:	// User declarations
	int Tag;
		GuiAlignInfo *Fgl;         // pointer to last info packet
		int FLastResult;
		char *Fscript;
		int Fscript_len;
		int ReadControlPoint	( GuiControlPoint * cptr, char *line);
		void readControlPoints(char* script, GuiControlPoint *cp );
		int ReadImageDescription( GuiImage *imPtr, stBuf *sPtr, char *line );
		int ReadModeDescription ( sPrefs *sP, char *line );
		int ReadCoordinates( 	CoordInfo	*cp, char *line );
		void nextWord( register char* word, char** ch );
		void nextLine( register char* line, char** ch );
		int numLines( char* script, char first );
		int getVRPanoOptions( VRPanoOptions *v, char *line );
		int readPositions( char* script, transformCoord *tP );
		int ReadMorphPoints( char *script, GuiAlignInfo *gl, int nIm );
		void SetCoordDefaults( CoordInfo *c, int num );
		//void __fastcall  PrintError(AnsiString str);
		void PrintError( char* str, bool showScript = false);
		void PrintError( char* str, int num, bool showScript = true);
		bool MoveImageAlignInfoData(GuiAlignInfo *gl, int destNr, int sourceNr);
		void FreeImAlignInfo(GuiAlignInfo *gl,int imNr);
public:		// User declarations
		TProjectParser(void);
		~TProjectParser(void);
		bool SetControls(wxTextCtrl *MainMemo, wxTextCtrl *LineNrMemo, wxTextCtrl *ErrorMemo);
		int ParseScript(wxString *src_script, GuiAlignInfo *gl, bool freshGl=true, bool setMemoScript=true);
		wxArrayString *PrintScript(PrintTarget target, GuiAlignInfo *g/*, double ds( int i), int launch*/);
		char *ReadLastScript(wxArrayString *);
		int FreeAlignInfo(GuiAlignInfo *g);
		char *AllocComment(char *s_in);
		char *AllocString(char *s_in, char *s_old);
		void FreeComment(char *s_in);
		void *ResizeMem(void *ptr, long new_size, long old_size);
		int ReserveSpace4Image2AlignInfo(GuiAlignInfo *gl);
		void SetGuiImageDefaults(GuiImage *im);
		void SetGuiOptDefaults( GuioptVars *opt );
		int AddImage2AlignInfo(GuiAlignInfo *gl);	// add one image
		bool DeleteImageFromAlignInfo(GuiAlignInfo *gl, int delNr);
		bool SwapImageAlignInfoData(GuiAlignInfo *gl, int sNr, int dNr);
		int AddControlPoint2AlignInfo(GuiAlignInfo *gl, int count=0);
		bool CopyOptimizedData(GuiAlignInfo *to_g, GuiAlignInfo *from_g, bool bg_process=false, bool OptimizationResult=true);
		bool CopyImageStitchData(GuiAlignInfo *to_g, GuiAlignInfo *from_g, bool bg_process=false);
		void ScaleProjectData(GuiAlignInfo *to_g, double factor, bool round_to_integer=false);
		wxString GetOptTypeString(int value);
};

//---------------------------------------------------------------------------
#endif
